diff --git a/app/Listeners/Registration/SendConfirmationEmail.php b/app/Listeners/Registration/SendConfirmationEmail.php
new file mode 100644
index 0000000..b1674f3
--- /dev/null
+++ b/app/Listeners/Registration/SendConfirmationEmail.php
@@ -0,0 +1,42 @@
+<?php
+
+namespace Portal\Listeners\Registration;
+
+use Portal\Events\User\Registered;
+use Portal\Notifications\EmailConfirmation;
+use Portal\Repositories\User\UserRepository;
+
+class SendConfirmationEmail
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+
+    public function __construct(UserRepository $users)
+    {
+        $this->users = $users;
+    }
+
+    /**
+     * Handle the event.
+     *
+     * @param  Registered  $event
+     * @return void
+     */
+    public function handle(Registered $event)
+    {
+        if (! settings('reg_email_confirmation')) {
+            return;
+        }
+
+        $user = $event->getRegisteredUser();
+
+        $token = str_random(60);
+        $this->users->update($user->id, [
+            'confirmation_token' => $token
+        ]);
+
+        $user->notify(new EmailConfirmation($token));
+    }
+}
diff --git a/app/Listeners/UserWasRegisteredListener.php b/app/Listeners/Registration/SendSignUpNotification.php
similarity index 76%
rename from app/Listeners/UserWasRegisteredListener.php
rename to app/Listeners/Registration/SendSignUpNotification.php
index 18064b1..de979c9 100644
--- a/app/Listeners/UserWasRegisteredListener.php
+++ b/app/Listeners/Registration/SendSignUpNotification.php
@@ -1,16 +1,12 @@
 <?php
 
-namespace Portal\Listeners;
+namespace Portal\Listeners\Registration;
 
 use Portal\Events\User\Registered;
-use Portal\Mailers\NotificationMailer;
-use Portal\Mailers\UserMailer;
 use Portal\Notifications\UserRegistered;
 use Portal\Repositories\User\UserRepository;
-use Illuminate\Queue\InteractsWithQueue;
-use Illuminate\Contracts\Queue\ShouldQueue;
 
-class UserWasRegisteredListener
+class SendSignUpNotification
 {
     /**
      * @var UserRepository
diff --git a/app/Permission.php b/app/Permission.php
index 1088bd2..a0b97bd 100644
--- a/app/Permission.php
+++ b/app/Permission.php
@@ -9,4 +9,8 @@ class Permission extends Model
     protected $table = 'permissions';
 
     protected $fillable = ['name', 'display_name', 'description'];
+
+    protected $casts = [
+        'removable' => 'boolean'
+    ];
 }
diff --git a/app/Providers/AuthServiceProvider.php b/app/Providers/AuthServiceProvider.php
index 290cfbb..941ea42 100644
--- a/app/Providers/AuthServiceProvider.php
+++ b/app/Providers/AuthServiceProvider.php
@@ -4,6 +4,7 @@ namespace Portal\Providers;
 
 use Illuminate\Contracts\Auth\Access\Gate as GateContract;
 use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;
+use Portal\User;
 
 class AuthServiceProvider extends ServiceProvider
 {
@@ -38,5 +39,13 @@ class AuthServiceProvider extends ServiceProvider
         \Blade::directive('endpermission', function ($expression) {
             return "<?php endif; ?>";
         });
+
+        \Gate::define('manage-session', function (User $user, $session) {
+            if ($user->hasPermission('users.manage')) {
+                return true;
+            }
+
+            return (int) $user->id === (int) $session->user_id;
+        });
     }
 }
diff --git a/app/Providers/EventServiceProvider.php b/app/Providers/EventServiceProvider.php
index 6fc7052..0a3262d 100644
--- a/app/Providers/EventServiceProvider.php
+++ b/app/Providers/EventServiceProvider.php
@@ -4,6 +4,8 @@ namespace Portal\Providers;
 
 use Portal\Events\User\Registered;
 use Portal\Listeners\PermissionEventsSubscriber;
+use Portal\Listeners\Registration\SendConfirmationEmail;
+use Portal\Listeners\Registration\SendSignUpNotification;
 use Portal\Listeners\RoleEventsSubscriber;
 use Portal\Listeners\UserEventsSubscriber;
 use Portal\Listeners\UserWasRegisteredListener;
@@ -17,7 +19,10 @@ class EventServiceProvider extends ServiceProvider
      * @var array
      */
     protected $listen = [
-        Registered::class => [UserWasRegisteredListener::class]
+        Registered::class => [
+            SendConfirmationEmail::class,
+            SendSignUpNotification::class,
+        ]
     ];
 
     /**
diff --git a/app/Providers/RouteServiceProvider.php b/app/Providers/RouteServiceProvider.php
index ad8eb7d..4a80543 100644
--- a/app/Providers/RouteServiceProvider.php
+++ b/app/Providers/RouteServiceProvider.php
@@ -5,6 +5,7 @@ namespace Portal\Providers;
 use Route;
 use Portal\Permission;
 use Portal\Repositories\Role\RoleRepository;
+use Portal\Repositories\Session\SessionRepository;
 use Portal\Repositories\User\UserRepository;
 use Illuminate\Routing\Router;
 use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
@@ -13,13 +14,17 @@ use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 class RouteServiceProvider extends ServiceProvider
 {
     /**
-     * This namespace is applied to the controller routes in your routes file.
-     *
+     * This namespace is applied to the controller routes in your web routes file.
      * In addition, it is set as the URL generator's root namespace.
-     *
      * @var string
      */
-    protected $namespace = 'Portal\Http\Controllers';
+    protected $webNamespace = 'Portal\Http\Controllers\Web';
+
+    /**
+     * This namespace is applied to the controller routes in your api routes file.
+     * @var string
+     */
+    protected $apiNamespace = 'Portal\Http\Controllers\Api';
 
     /**
      * Define your route model bindings, pattern filters, etc.
@@ -32,6 +37,7 @@ class RouteServiceProvider extends ServiceProvider
 
         $this->bindUser();
         $this->bindRole();
+        $this->bindSession();
     }
 
     /**
@@ -41,7 +47,9 @@ class RouteServiceProvider extends ServiceProvider
      */
     public function map()
     {
-        $this->mapApiRoutes();
+        if ($this->app['config']->get('auth.expose_api')) {
+            $this->mapApiRoutes();
+        }
 
         $this->mapWebRoutes();
     }
@@ -56,7 +64,7 @@ class RouteServiceProvider extends ServiceProvider
     protected function mapWebRoutes()
     {
         Route::group([
-            'namespace' => $this->namespace,
+            'namespace' => $this->webNamespace,
             'middleware' => 'web',
         ], function ($router) {
             require base_path('routes/web.php');
@@ -74,7 +82,7 @@ class RouteServiceProvider extends ServiceProvider
     {
         Route::group([
             'middleware' => 'api',
-            'namespace' => $this->namespace,
+            'namespace' => $this->apiNamespace,
             'prefix' => 'api',
         ], function () {
             require base_path('routes/api.php');
@@ -91,6 +99,11 @@ class RouteServiceProvider extends ServiceProvider
         $this->bindUsingRepository('role', RoleRepository::class);
     }
 
+    private function bindSession()
+    {
+        $this->bindUsingRepository('session', SessionRepository::class);
+    }
+
     private function bindUsingRepository($entity, $repository, $method = 'find')
     {
         Route::bind($entity, function ($id) use ($repository, $method) {
@@ -98,7 +111,7 @@ class RouteServiceProvider extends ServiceProvider
                 return $object;
             }
 
-            throw new NotFoundHttpException;
+            throw new NotFoundHttpException("Resource not found.");
         });
     }
 }
diff --git a/app/Repositories/Country/CountryRepository.php b/app/Repositories/Country/CountryRepository.php
index 43ff28c..c05afec 100644
--- a/app/Repositories/Country/CountryRepository.php
+++ b/app/Repositories/Country/CountryRepository.php
@@ -12,4 +12,10 @@ interface CountryRepository
      * @return mixed
      */
     public function lists($column = 'name', $key = 'id');
-}
\ No newline at end of file
+
+    /**
+     * Get all available countries.
+     * @return mixed
+     */
+    public function all();
+}
diff --git a/app/Repositories/Country/EloquentCountry.php b/app/Repositories/Country/EloquentCountry.php
index 0577a13..8a04bf8 100644
--- a/app/Repositories/Country/EloquentCountry.php
+++ b/app/Repositories/Country/EloquentCountry.php
@@ -13,4 +13,12 @@ class EloquentCountry implements CountryRepository
     {
         return Country::orderBy('name')->pluck($column, $key);
     }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function all()
+    {
+        return Country::all();
+    }
 }
diff --git a/app/Repositories/Role/EloquentRole.php b/app/Repositories/Role/EloquentRole.php
index 2fa873b..88b15d7 100644
--- a/app/Repositories/Role/EloquentRole.php
+++ b/app/Repositories/Role/EloquentRole.php
@@ -24,12 +24,7 @@ class EloquentRole implements RoleRepository
      */
     public function getAllWithUsersCount()
     {
-        $prefix = DB::getTablePrefix();
-
-        return Role::leftJoin('users', 'roles.id', '=', 'users.role_id')
-            ->select('roles.*', DB::raw("count({$prefix}users.id) as users_count"))
-            ->groupBy('roles.id')
-            ->get();
+        return Role::withCount('users')->get();
     }
 
     /**
diff --git a/app/Repositories/Session/DbSession.php b/app/Repositories/Session/DbSession.php
index c5d93cd..b5e1144 100644
--- a/app/Repositories/Session/DbSession.php
+++ b/app/Repositories/Session/DbSession.php
@@ -32,20 +32,31 @@ class DbSession implements SessionRepository
         return DB::table('sessions')
             ->where('user_id', $userId)
             ->where('last_activity', '>=', $validTimestamp)
-            ->get(['id', 'ip_address', 'user_agent', 'last_activity'])
+            ->get()
             ->all();
     }
 
     /**
      * {@inheritdoc}
      */
-    public function invalidateUserSession($userId, $sessionId)
+    public function invalidateSession($sessionId)
     {
+        $user = $this->users->findBySessionId($sessionId);
+
         DB::table('sessions')
-            ->where('user_id', $userId)
             ->where('id', $sessionId)
             ->delete();
 
-        $this->users->update($userId, ['remember_token' => null]);
+        $this->users->update($user->id, ['remember_token' => null]);
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function find($sessionId)
+    {
+        return DB::table('sessions')
+            ->where('id', $sessionId)
+            ->first();
     }
-}
\ No newline at end of file
+}
diff --git a/app/Repositories/Session/SessionRepository.php b/app/Repositories/Session/SessionRepository.php
index d09752f..c061d65 100644
--- a/app/Repositories/Session/SessionRepository.php
+++ b/app/Repositories/Session/SessionRepository.php
@@ -5,6 +5,13 @@ namespace Portal\Repositories\Session;
 interface SessionRepository
 {
     /**
+     * Find session by id.
+     * @param $sessionId
+     * @return mixed
+     */
+    public function find($sessionId);
+
+    /**
      * Get all active sessions for specified user.
      *
      * @param $userId
@@ -15,9 +22,8 @@ interface SessionRepository
     /**
      * Invalidate specified session for provided user
      *
-     * @param $userId
      * @param $sessionId
      * @return mixed
      */
-    public function invalidateUserSession($userId, $sessionId);
-}
\ No newline at end of file
+    public function invalidateSession($sessionId);
+}
diff --git a/app/Repositories/User/EloquentUser.php b/app/Repositories/User/EloquentUser.php
index 1de4a76..7e4368b 100644
--- a/app/Repositories/User/EloquentUser.php
+++ b/app/Repositories/User/EloquentUser.php
@@ -59,12 +59,19 @@ class EloquentUser implements UserRepository
     /**
      * {@inheritdoc}
      */
-    public function create(array $data)
+    public function findBySessionId($sessionId)
     {
-        if (! array_get($data, 'country_id')) {
-            $data['country_id'] = null;
-        }
+        return User::leftJoin('sessions', 'users.id', '=', 'sessions.user_id')
+            ->select('users.*')
+            ->where('sessions.id', $sessionId)
+            ->first();
+    }
 
+    /**
+     * {@inheritdoc}
+     */
+    public function create(array $data)
+    {
         return User::create($data);
     }
 
@@ -102,7 +109,7 @@ class EloquentUser implements UserRepository
             });
         }
 
-        $result = $query->orderBy('created_at', 'desc')
+        $result = $query->orderBy('id', 'desc')
             ->paginate($perPage);
 
         if ($search) {
@@ -117,21 +124,11 @@ class EloquentUser implements UserRepository
      */
     public function update($id, array $data)
     {
-        if (array_has($data, 'country_id')) {
-            $countryId = array_get($data, 'country_id');
-
-            $data['country_id'] = $countryId ?: null;
-        }
+        $user = $this->find($id);
 
-        return $this->find($id)->update($data);
-    }
+        $user->update($data);
 
-    /**
-     * {@inheritdoc}
-     */
-    public function updateSocialNetworks($userId, array $data)
-    {
-        return $this->find($userId)->socialNetworks()->updateOrCreate([], $data);
+        return $user;
     }
 
     /**
diff --git a/app/Repositories/User/UserRepository.php b/app/Repositories/User/UserRepository.php
index 9243dd5..221b76c 100644
--- a/app/Repositories/User/UserRepository.php
+++ b/app/Repositories/User/UserRepository.php
@@ -36,13 +36,21 @@ interface UserRepository
     /**
      * Find user registered via social network.
      *
-     * @param $provider Provider used for authentication.
-     * @param $providerId Provider's unique identifier for authenticated user.
+     * @param $provider string Provider used for authentication.
+     * @param $providerId string Provider's unique identifier for authenticated user.
      * @return mixed
      */
     public function findBySocialId($provider, $providerId);
 
     /**
+     * Find user by specified session id.
+     *
+     * @param $sessionId
+     * @return mixed
+     */
+    public function findBySessionId($sessionId);
+
+    /**
      * Create new user.
      *
      * @param array $data
@@ -55,7 +63,7 @@ interface UserRepository
      *
      * @param $id
      * @param array $data
-     * @return mixed
+     * @return User
      */
     public function update($id, array $data);
 
@@ -79,14 +87,6 @@ interface UserRepository
     public function associateSocialAccountForUser($userId, $provider, SocialUser $user);
 
     /**
-     * Update user social networks.
-     * @param $userId
-     * @param array $data
-     * @return mixed
-     */
-    public function updateSocialNetworks($userId, array $data);
-
-    /**
      * Number of users in database.
      *
      * @return mixed
diff --git a/app/Services/Auth/Api/ExtendsJwtValidation.php b/app/Services/Auth/Api/ExtendsJwtValidation.php
new file mode 100644
index 0000000..a234e8d
--- /dev/null
+++ b/app/Services/Auth/Api/ExtendsJwtValidation.php
@@ -0,0 +1,69 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+use Carbon\Carbon;
+use Tymon\JWTAuth\Exceptions\TokenInvalidException;
+
+trait ExtendsJwtValidation
+{
+    protected $jtiIsValid;
+
+    /**
+     * {@inheritdoc}
+     */
+    public function getPayload()
+    {
+        $payload = parent::getPayload();
+
+        $jti = $payload->get('jti');
+        $id = $payload->get('sub');
+
+        if (! $this->jtiIsValid($jti, $id)) {
+            throw new TokenInvalidException("Invalid jti claim.");
+        }
+
+        return $payload;
+    }
+
+    /**
+     * Check if jti claim is valid. For jti claim we use our random
+     * generated token that is being stored inside the database, so
+     * we can easily revoke it anytime we want.
+     *
+     * Remember, the jti claim is not a token itself that is being used
+     * for API authentication. It is just a unique string (more like token ID)
+     * attached to each JWT token to allow us to easily revoke that JWT token later.
+     * @param $jti
+     * @param $userId
+     * @return bool
+     */
+    private function jtiIsValid($jti, $userId)
+    {
+        if (is_null($this->jtiIsValid)) {
+            $count = Token::where('id', $jti)
+                ->where('user_id', $userId)
+                ->where('expires_at', '>', Carbon::now())
+                ->count();
+
+            $this->jtiIsValid = $count == 1;
+        }
+
+
+        return $this->jtiIsValid;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function invalidate($forceForever = true)
+    {
+        $this->requireToken();
+
+        Token::where('id', $this->getClaim('jti'))->delete();
+
+        $this->jtiIsValid = null;
+
+        return $this;
+    }
+}
diff --git a/app/Services/Auth/Api/JWT.php b/app/Services/Auth/Api/JWT.php
new file mode 100644
index 0000000..5318465
--- /dev/null
+++ b/app/Services/Auth/Api/JWT.php
@@ -0,0 +1,8 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+class JWT extends \Tymon\JWTAuth\JWT
+{
+    use ExtendsJwtValidation;
+}
diff --git a/app/Services/Auth/Api/JWTAuth.php b/app/Services/Auth/Api/JWTAuth.php
new file mode 100644
index 0000000..a909408
--- /dev/null
+++ b/app/Services/Auth/Api/JWTAuth.php
@@ -0,0 +1,8 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+class JWTAuth extends \Tymon\JWTAuth\JWTAuth
+{
+    use ExtendsJwtValidation;
+}
diff --git a/app/Services/Auth/Api/JWTServiceProvider.php b/app/Services/Auth/Api/JWTServiceProvider.php
new file mode 100644
index 0000000..4f6b780
--- /dev/null
+++ b/app/Services/Auth/Api/JWTServiceProvider.php
@@ -0,0 +1,39 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+use Tymon\JWTAuth\Providers\LaravelServiceProvider;
+
+class JWTServiceProvider extends LaravelServiceProvider
+{
+    /**
+     * Register the bindings for the main JWT class.
+     *
+     * @return void
+     */
+    protected function registerJWT()
+    {
+        $this->app->singleton('tymon.jwt', function ($app) {
+            return new JWT(
+                $app['tymon.jwt.manager'],
+                $app['tymon.jwt.parser']
+            );
+        });
+    }
+
+    /**
+     * Register the bindings for the main JWTAuth class.
+     *
+     * @return void
+     */
+    protected function registerJWTAuth()
+    {
+        $this->app->singleton('tymon.jwt.auth', function ($app) {
+            return new JWTAuth(
+                $app['tymon.jwt.manager'],
+                $app['tymon.jwt.provider.auth'],
+                $app['tymon.jwt.parser']
+            );
+        });
+    }
+}
diff --git a/app/Services/Auth/Api/Token.php b/app/Services/Auth/Api/Token.php
new file mode 100644
index 0000000..3e56d53
--- /dev/null
+++ b/app/Services/Auth/Api/Token.php
@@ -0,0 +1,12 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+use Illuminate\Database\Eloquent\Model;
+
+class Token extends Model
+{
+    protected $table = 'api_tokens';
+
+    public $incrementing = false;
+}
diff --git a/app/Services/Auth/Api/TokenFactory.php b/app/Services/Auth/Api/TokenFactory.php
new file mode 100644
index 0000000..2306323
--- /dev/null
+++ b/app/Services/Auth/Api/TokenFactory.php
@@ -0,0 +1,79 @@
+<?php
+
+namespace Portal\Services\Auth\Api;
+
+use Carbon\Carbon;
+use Illuminate\Http\Request;
+use Portal\User;
+use Illuminate\Contracts\Config\Repository as ConfigContract;
+
+class TokenFactory
+{
+    /**
+     * @var Request
+     */
+    private $request;
+
+    /**
+     * @var ConfigContract
+     */
+    private $config;
+
+    /**
+     * TokenFactory constructor.
+     * @param Request $request
+     * @param ConfigContract $config
+     */
+    public function __construct(Request $request, ConfigContract $config)
+    {
+        $this->request = $request;
+        $this->config = $config;
+    }
+
+    /**
+     * Create new token for specified user.
+     * @param User $user
+     * @return Token
+     */
+    public function forUser(User $user)
+    {
+        $ttl = $this->config->get('jwt.ttl');
+
+        $token = (new Token)->forceFill([
+            'id' => str_random(40),
+            'user_id' => $user->id,
+            'ip_address' => $this->request->ip(),
+            'user_agent' => $this->getUserAgent(),
+            'expires_at' => is_null($ttl) ? null : Carbon::now()->addMinutes($ttl)
+        ]);
+
+        $token->save();
+
+        if ($this->shouldCleanUp()) {
+            Token::where('expires_at', '<=', Carbon::now())->delete();
+        }
+
+        return $token;
+    }
+
+    /**
+     * Get user agent from request headers.
+     *
+     * @return string
+     */
+    private function getUserAgent()
+    {
+        return substr((string) $this->request->header('User-Agent'), 0, 500);
+    }
+
+    /**
+     * Determine if we should clean up expired tokens.
+     * @return bool
+     */
+    protected function shouldCleanUp()
+    {
+        $lottery = $this->config->get('jwt.lottery');
+
+        return random_int(1, $lottery[1]) <= $lottery[0];
+    }
+}
diff --git a/app/Services/Auth/Social/SocialManager.php b/app/Services/Auth/Social/SocialManager.php
new file mode 100644
index 0000000..f74548d
--- /dev/null
+++ b/app/Services/Auth/Social/SocialManager.php
@@ -0,0 +1,85 @@
+<?php
+
+namespace Portal\Services\Auth\Social;
+
+use Laravel\Socialite\Contracts\User as SocialUser;
+use Portal\Repositories\Role\RoleRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Support\Enum\UserStatus;
+
+class SocialManager
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+    /**
+     * @var RoleRepository
+     */
+    private $roles;
+
+    /**
+     * SocialManager constructor.
+     * @param UserRepository $users
+     * @param RoleRepository $roles
+     */
+    public function __construct(UserRepository $users, RoleRepository $roles)
+    {
+        $this->users = $users;
+        $this->roles = $roles;
+    }
+
+    /**
+     * Associate social user with given provider. If user with the same email address
+     * retrieved from social network exists in our database, we will just associate it
+     * with provided social account. If not, user will be created.
+     *
+     * @param SocialUser $socialUser
+     * @param string $provider
+     * @return mixed|null|\Portal\User
+     */
+    public function associate(SocialUser $socialUser, $provider)
+    {
+        $user = $this->users->findByEmail($socialUser->getEmail());
+
+        if (! $user) {
+            // User with email retrieved from social auth provider does not
+            // exist in our database. That means that we have to create new user here
+            list($firstName, $lastName) = $this->parseUserFullName($socialUser);
+
+            $role = $this->roles->findByName('User');
+
+            $user = $this->users->create([
+                'email' => $socialUser->getEmail(),
+                'password' => str_random(10),
+                'first_name' => $firstName,
+                'last_name' => $lastName,
+                'status' => UserStatus::ACTIVE,
+                'avatar' => $socialUser->getAvatar(),
+                'role_id' => $role->id
+            ]);
+        }
+
+        // Associate social account with user account inside our application
+        $this->users->associateSocialAccountForUser($user->id, $provider, $socialUser);
+
+        return $user;
+    }
+
+    /**
+     * Parse User's name from his social network account.
+     *
+     * @param SocialUser $user
+     * @return array
+     */
+    private function parseUserFullName(SocialUser $user)
+    {
+        $name = $user->getName();
+
+        if (strpos($name, " ") !== false) {
+            return explode(" ", $name, 2);
+        }
+
+        return [$name, ''];
+    }
+}
diff --git a/app/Services/Logging/UserActivity/Logger.php b/app/Services/Logging/UserActivity/Logger.php
index 6bb7a49..66f1b38 100644
--- a/app/Services/Logging/UserActivity/Logger.php
+++ b/app/Services/Logging/UserActivity/Logger.php
@@ -2,9 +2,9 @@
 
 namespace Portal\Services\Logging\UserActivity;
 
+use Illuminate\Contracts\Auth\Factory;
 use Portal\Repositories\Activity\ActivityRepository;
 use Portal\User;
-use Illuminate\Contracts\Auth\Guard;
 use Illuminate\Http\Request;
 
 class Logger
@@ -14,7 +14,7 @@ class Logger
      */
     private $request;
     /**
-     * @var Guard
+     * @var Factory
      */
     private $auth;
 
@@ -27,7 +27,7 @@ class Logger
      */
     private $activities;
 
-    public function __construct(Request $request, Guard $auth, ActivityRepository $activities)
+    public function __construct(Request $request, Factory $auth, ActivityRepository $activities)
     {
         $this->request = $request;
         $this->auth = $auth;
@@ -63,7 +63,7 @@ class Logger
             return $this->user->id;
         }
 
-        return $this->auth->id();
+        return $this->auth->guard()->id();
     }
 
     /**
@@ -83,4 +83,4 @@ class Logger
     {
         $this->user = $user;
     }
-}
\ No newline at end of file
+}
diff --git a/app/Services/Upload/UserAvatarManager.php b/app/Services/Upload/UserAvatarManager.php
index f4be86a..7bc2c23 100644
--- a/app/Services/Upload/UserAvatarManager.php
+++ b/app/Services/Upload/UserAvatarManager.php
@@ -2,9 +2,9 @@
 
 namespace Portal\Services\Upload;
 
+use Illuminate\Http\UploadedFile;
 use Portal\User;
 use Illuminate\Filesystem\Filesystem;
-use Illuminate\Http\Request;
 use Intervention\Image\ImageManager;
 use Symfony\Component\HttpFoundation\File\File;
 
@@ -27,30 +27,27 @@ class UserAvatarManager
      * @var ImageManager
      */
     private $imageManager;
-    /**
-     * @var Request
-     */
-    private $request;
 
-    public function __construct(Filesystem $fs, ImageManager $imageManager, Request $request)
+    public function __construct(Filesystem $fs, ImageManager $imageManager)
     {
         $this->fs = $fs;
         $this->imageManager = $imageManager;
-        $this->request = $request;
     }
 
     /**
      * Upload and crop user avatar to predefined width and height.
      *
      * @param User $user
+     * @param UploadedFile $file
+     * @param array|null $cropPoints
      * @return string Avatar file name.
      */
-    public function uploadAndCropAvatar(User $user)
+    public function uploadAndCropAvatar(User $user, UploadedFile $file, array $cropPoints = null)
     {
-        list($name, $avatarImage) = $this->uploadFile($user);
+        list($name, $avatarImage) = $this->saveFile($file);
 
         try {
-            $this->cropAndResizeImage($avatarImage);
+            $this->cropAndResizeImage($avatarImage, $cropPoints);
             $this->deleteAvatarIfUploaded($user);
         } catch (\Exception $e) {
             logger("Cannot upload avatar. " . $e->getMessage());
@@ -62,16 +59,6 @@ class UserAvatarManager
     }
 
     /**
-     * Get uploaded file from HTTP request.
-     *
-     * @return array|null|\Symfony\Component\HttpFoundation\File\UploadedFile
-     */
-    private function getUploadedFileFromRequest()
-    {
-        return $this->request->file('avatar');
-    }
-
-    /**
      * Check if user has uploaded avatar photo.
      * If he is using some external url for avatar, then
      * it is assumed that avatar is not uploaded manually.
@@ -85,18 +72,19 @@ class UserAvatarManager
     }
 
     /**
-     * Upload avatar photo for provided user and
-     * delete old avatar if exists.
+     * Save avatar for provided user.
      *
-     * @param User $user
+     * @param UploadedFile $uploadedFile
      * @return array
      */
-    private function uploadFile(User $user)
+    private function saveFile(UploadedFile $uploadedFile)
     {
         $name = $this->generateAvatarName();
-        $uploadedFile = $this->getUploadedFileFromRequest();
 
-        $targetFile = $uploadedFile->move($this->getDestinationDirectory(), $name);
+        $targetFile = $uploadedFile->move(
+            $this->getDestinationDirectory(),
+            $name
+        );
 
         return [$name, $targetFile];
     }
@@ -116,10 +104,17 @@ class UserAvatarManager
      */
     public function deleteAvatarIfUploaded(User $user)
     {
-        if ($this->userHasUploadedAvatar($user)) {
-            $path = sprintf("%s/%s", $this->getDestinationDirectory(), $user->avatar);
-            $this->fs->delete($path);
+        if (! $this->userHasUploadedAvatar($user)) {
+            return;
         }
+
+        $path = sprintf(
+            "%s/%s",
+            $this->getDestinationDirectory(),
+            $user->avatar
+        );
+
+        $this->fs->delete($path);
     }
 
     /**
@@ -129,13 +124,7 @@ class UserAvatarManager
      */
     private function generateAvatarName()
     {
-        $file = $this->getUploadedFileFromRequest();
-
-        return sprintf(
-            "%s.%s",
-            md5(str_random() . time()),
-            $file->getClientOriginalExtension()
-        );
+        return sprintf("%s.png", str_random());
     }
 
     /**
@@ -143,19 +132,28 @@ class UserAvatarManager
      * resize it to predefined width and height.
      *
      * @param File $avatarImage
+     * @param array|null $points
      * @return \Intervention\Image\Image
      */
-    private function cropAndResizeImage(File $avatarImage)
+    private function cropAndResizeImage(File $avatarImage, array $points = null)
     {
-        $points = $this->request->get('points');
-        $image = $this->imageManager->make($avatarImage->getRealPath());
+        $image = $this->imageManager->make(
+            $avatarImage->getRealPath()
+        );
 
-        // Calculate delta between two points on X axis. This
-        // value will be used as width and height for cropped image.
-        $size = floor($points['x2'] - $points['x1']);
+        if ($points) {
+            // Calculate delta between two points on X axis. This
+            // value will be used as width and height for cropped image.
+            $size = floor($points['x2'] - $points['x1']);
+
+            return $image->crop($size, $size, (int) $points['x1'], (int) $points['y1'])
+                ->resize(self::AVATAR_WIDTH, self::AVATAR_HEIGHT)
+                ->save();
+        }
 
-        return $image->crop($size, $size, (int) $points['x1'], (int) $points['y1'])
-            ->resize(self::AVATAR_WIDTH, self::AVATAR_HEIGHT)
+        // If crop points are not provided, we will just crop
+        // provided image to specified width and height.
+        return $image->crop(self::AVATAR_WIDTH, self::AVATAR_HEIGHT)
             ->save();
     }
 }
\ No newline at end of file
